// --------------------------------------------------------------------
// Author  : mashimonator
// Create  : 2009/01/17
// Update  : 2009/01/17
// Description : 擬似的にIEのruby要素を再現する
// --------------------------------------------------------------------

var ruby = {

	//-----------------------------------------
	// 設定値
	//-----------------------------------------
	conf : {

		clsName : 'ruby',          // 対象とするクラス名
		targetTag : 'span',        // 対象とする要素名
		rp : ['（','）'],          // ルビの内容を囲む記号
		currentVal : 0             // 初期表示設定(0:表示されて開始/1:非表示で開始)

	},

	//-----------------------------------------
	// Main処理(rubyの表示切り替え)
	//-----------------------------------------
	change : function() {

		var userSystem = new ruby.getBrowserInfo(navigator.userAgent);
		var elements = ruby.getTargetElements(ruby.conf.targetTag, ruby.conf.clsName, ruby.conf.currentVal);
		var div = document.getElementById('ruby');

		// 初期表示設定によって切り替え
		if (ruby.conf.currentVal == 0) {
			ruby.disp(elements, ruby.conf.clsName, ruby.conf.rp, userSystem.browserShortName);
			ruby.conf.currentVal = 1;
			if (div) {
				div.className = 'rubyStyle';
			}
		} else {
			ruby.hide(elements, ruby.conf.clsName, ruby.conf.rp, userSystem.browserShortName);
			ruby.conf.currentVal = 0;
			if (div) {
				div.className = 'normalStyle';
			}
		}

	},

	//-----------------------------------------
	// 表示
	//-----------------------------------------
	disp : function(elements, cls, rp, browser) {

		var rubyLengthClassName = Array('one','two','three','four','five');
		
		for (var i = 0; i < elements.length; i++) {
			
			var element = elements[i];
			var str = element.innerHTML;
			
			if (browser == "ie") {
				// for IE
				str = str.replace(/<SPAN class=rp>/g, '');
				str = str.replace(/<\/SPAN>/g, '');
			} else {
				str = str.replace('<span class=\"rp\">', '', 'i');
				str = str.replace('</span>', '', 'i');
			}
			
			if (str) {
				var ruby = Array(
					'<span class=\"rb\">',
					str.substr(0, str.indexOf(rp[0])),
					'</span><span class=\"rp\">' + rp[0] + '</span><span class=\"rt\">',
					str.substr(str.indexOf(rp[0]) + 1, str.length - str.indexOf(rp[0]) - 2),
					'</span><span class=\"rp\">' + rp[1] + '</span>'
				);
				element.innerHTML = ruby.join('');
				element.className = cls + ' ' + rubyLengthClassName[str.indexOf(rp[0]) - 1];
			}
			
		}

	},

	//-----------------------------------------
	// 非表示
	//-----------------------------------------
	hide : function(elements, cls, rp, browser) {
		
		for (var i = 0; i < elements.length; i++) {
			
			var element = elements[i];
			var str = element.innerHTML;
			
			if (browser == "ie") {
				// for IE
				str = str.replace(/> /g, '>');
				str = str.replace(/<SPAN class=rb>/g, '');
				str = str.replace(/<\/SPAN><SPAN class=rp>/g, '');
				str = str.replace(/<\/SPAN><SPAN class=rt>/g, '');
				str = str.replace(/<\/SPAN>/g, '');
			} else {
				str = str.replace(/[\n\r]/g, '');
				str = str.replace('<span class=\"rb\">', '', 'i');
				str = str.replace('</span><span class=\"rp\">' + rp[0] + '</span><span class=\"rt\">', rp[0], 'i');
				str = str.replace('</span><span class=\"rp\">' + rp[1] + '</span>', rp[1], 'i');
			}
			
			var ruby = Array(
					str.substr(0, str.indexOf(rp[0])),
					'<span class=\"rp\">'+ rp[0],
					str.substr(str.indexOf(rp[0]) + 1, str.length - str.indexOf(rp[0]) - 2),
					rp[1] + '</span>'
			);
			
			str = ruby.join('');
			
			element.innerHTML = str;
			element.className = cls;
			
		}

	},

	//-----------------------------------------
	// ターゲットタグを取得する
	//-----------------------------------------
	getTargetElements : function(tag, cls, mode) {

		var elements = new Array();
		var targetElements = document.getElementsByTagName(tag);

		if (mode == 0) {
			
			// 表示用
			for (var i = 0; i < targetElements.length; i++) {
				if (targetElements[i].className == cls) {
					elements[elements.length] = targetElements[i];
				}
			}
			
		} else {
			
			// 非表示用
			for (var i = 0; i < targetElements.length; i++) {
				if (targetElements[i].className.match(cls)) {
					elements[elements.length] = targetElements[i];
				}
			}
			
		}

		return elements;

	},

	//-----------------------------------------
	// ブラウザ情報取得
	//-----------------------------------------
	getBrowserInfo : function() {

		var key, index, keyIndex, keyIndexEnd, versionKey, i, j;
		var uaString = navigator.userAgent.toUpperCase();

		this.browserLongName = "---";
		this.browserShortName = "---";
		this.browserVersion = "---";

		var BROWSERS = new Object();
		BROWSERS['MZ'] = new setBrowser('Mozilla','mz','GECKO');
		BROWSERS['IE'] = new setBrowser('Internet Explorer','ie','MSIE');
		BROWSERS['AO'] = new setBrowser('AOL','ao','AOL');
		BROWSERS['SF'] = new setBrowser('Safari','sf','SAFARI');
		BROWSERS['OP'] = new setBrowser('Opera','op','OPERA');
		BROWSERS['OW'] = new setBrowser('OmniWeb','ow','OMNIWEB');
		BROWSERS['IC'] = new setBrowser('iCab','ic','ICAB');
		BROWSERS['NS'] = new setBrowser('Netscape','ns','NETSCAPE,NETSCAPE6');
		BROWSERS['NN'] = new setBrowser('Netscape Navigator','nn','MOZILLA');
		BROWSERS['FF'] = new setBrowser('Firefox','ff','FIREFOX');


		var UNIXDETAIL = new Array("LNX","BSD");
		var checkVersionExp01 = new Array(' ', '/', '-', '');
		var checkVersionExp02 = new Array(';', ' ', '(', '[', ')', '+', '-', '/');

		uaString = " " + uaString + ";";
		

		index = 0;
		for (key in BROWSERS) {
			for (i=0; i<BROWSERS[key].keyword.length; i++) {
				keyIndex = uaString.indexOf(BROWSERS[key].keyword[i].toUpperCase());
				if (keyIndex > index) {
					this.browserLongName = BROWSERS[key].longName;
					this.browserShortName = BROWSERS[key].shortName;
					versionKey = BROWSERS[key].keyword[i].toUpperCase();
					index = keyIndex;
				}
			}
		}

		// Navigator is reary?
		if (this.browserShortName == "nn" && uaString.indexOf("COMPATIBLE")>0) {
			this.browserLongName = "---";
			this.browserShortName = "---";
		}

		// Version Check
		if (this.browserLongName != "---") {
			for (i=0; i<checkVersionExp01.length; i++) {
				key = versionKey + checkVersionExp01[i];
				if ( ( keyIndex = uaString.indexOf(key) ) > 0 ) break;
			}
			// Mozilla
			if ( key == 'GECKO/' ) {
				key = 'RV:';
				keyIndex = uaString.indexOf(key);
			}
			keyIndex = keyIndex + key.length;
			index = uaString.length;
			for (i=0; i<checkVersionExp02.length; i++) {
				if ((key = uaString.indexOf(checkVersionExp02[i], keyIndex)) > 0) {
					if (key < index) {
						keyIndexEnd = key;
						index = keyIndexEnd;
					}
				}
			}
			this.browserVersion = uaString.substring(keyIndex, keyIndexEnd);
		}

		function setBrowser(longName,shortName,keyWord) {
			this.longName = longName;
			this.shortName = shortName;
			this.keyword = keyWord.split(",");
		}

	},

	//-----------------------------------------
	// Loadイベントに追加
	//-----------------------------------------
	addLoadEvent : function() {
		try {
			window.addEventListener('load', this.change, false);
		} catch (e) {
			window.attachEvent('onload', this.change);
		}
	}

}

ruby.addLoadEvent();